# TODO: make some things globally present? rob does this in his module. i guess it saves calculations but not sure if im gonna do that now


def flat(parameter):
    """
    Dummt distribution function that returns 1
    """
    return 1


def number(value):
    """
    Dummy distribution function that returns the input
    """
    return value


def powerlaw_constant(min_val, max_val, k):
    """
    Function that returns the constant to normalise a powerlaw
    """

    k1 = k + 1.0
    print(
        "Powerlaw consts from {} to {}, k={} where k1={}".format(
            min_val, max_val, k, k1
        )
    )

    powerlaw_const = k1 / (max_val ** k1 - min_val ** k1)
    return powerlaw_const


def powerlaw(min_val, max_val, k, x):
    """
    Single powerlaw with index k at x from min to max
    """

    # Handle faulty value
    if k == -1:
        print("wrong value for k")
        raise ValueError

    if (x < min_val) or (x > max_val):
        return 0

    else:
        const = powerlaw_constant(min_val, max_val, k)

        # powerlaw
        y = const * (x ** k)
        print(
            "Power law from {} to {}: const = {}, y = {}".format(
                min_val, max_val, const, y
            )
        )
        return y


# sub const
# {
#     # a constant distribution function between min=$_[0] and max=$_[1]
#     # $_[2] is optional (if given, perform a range check)

#     my $C= (defined($_[2]) && (($_[2]<$_[0]) || ($_[2]>$_[1]))) ? 0.0 : (1.0/($_[1]-$_[0]));
#     #printf "CONST $_[0] to $_[1] ($_[2]) $C\n";
#     return $C;
# }

# sub initialize_three_part_power_law_consts
# {
#     local $SIG{__DIE__} = sub { Carp::confess @_ };
#     # calculate constants for this power law
#     my ($m0,$m1,$m2,$mmax,$p1,$p2,$p3)=@_;
#     #print "INIT three-part power law m0=$m0 m1=$m1 m2=$m2 mmax=$mmax p1=$p1 p2=$p2 p3=$p3\n";
#     my $array=[];

#     $$array[1]=(($m1**$p2)*($m1**(-$p1)))*
#     (1.0/(1.0+$p1))*
#     ($m1**(1.0+$p1)-$m0**(1.0+$p1))+
#     (($m2**(1.0+$p2)-$m1**(1.0+$p2)))*
#     (1.0/(1.0+$p2))+
#     (($m2**$p2)*($m2**(-$p3)))*
#     (1.0/(1.0+$p3))*
#     ($mmax**(1.0+$p3)-$m2**(1.0+$p3));
#     $$array[1]=1.0/($$array[1]+1e-50);
#     $$array[0]=$$array[1]*$m1**$p2*$m1**(-$p1);
#     $$array[2]=$$array[1]*$m2**$p2*$m2**(-$p3);

#     #print "ARRAY SET @_ => @$array\n";
#     $threepart_powerlaw_consts{"@_"}=[@$array];
# }

# sub ktg93_lnspace
# {
#     # wrapper for KTG93 on a ln(m) grid
#     my $m=$_[0];
#     return ktg93(@_) * $m;
# }

# sub setopts
# {
#     # wrapper to take a hash (reference) of options,
#     # override with $newopts (where appropriate) and
#     # return the hash of options
#     my $opts=$_[0];
#     my $newopts=$_[1];
#     if(defined $newopts)
#     {
#     # newopts is a hash of new options
#     foreach my $opt (keys %$newopts)
#     {
#         # overwrite opt
#         $$opts{$opt} = $$newopts{$opt};
#     }
#     }
#     return $opts;
# }

# sub Kroupa2001
# {
#     my $m=$_[0];
#     my $newopts=$_[1];

#     # default parameters
#     my $opts=setopts({m0=>0.1,
#               m1=>0.5,
#               m2=>1.0,
#               mmax=>100.0,
#               p1=>-1.3,
#               p2=>-2.3,
#               p3=>-2.3},
#              $newopts);

#     return three_part_power_law($m,
#                 $$opts{m0},
#                 $$opts{m1},
#                 $$opts{m2},
#                 $$opts{mmax},
#                 $$opts{p1},
#                 $$opts{p2},
#                 $$opts{p3});
# }

# sub ktg93
# {
#     # wrapper for the mass distribution of KTG93
#     my ($m,$newopts)=@_;

#     if($m eq 'uncertainties')
#     {
#     # return (pointer to) the uncertainties hash
#     return {
#         m0=>{default=>0.1,
#          fixed=>1},
#         m1=>{default=>0.5,
#          fixed=>1},
#         m2=>{default=>1.0,
#          fixed=>1},
#         mmax=>{default=>80.0,
#            fixed=>1},
#         p1=>{default=>-1.3,
#          low=>-1.3,
#          high=>-1.3},
#         p2=>{default=>-2.2,
#          low=>-2.2,
#          high=>-2.2},
#         p3=>{default=>-2.7,
#          low=>-2.7,
#          high=>-2.7}
#     };
#     }

#     # set options
#     my $opts=setopts({m0=>0.1,
#               m1=>0.5,
#               m2=>1.0,
#               mmax=>80.0,
#               p1=>-1.3,
#               p2=>-2.2,
#               p3=>-2.7},
#              $newopts);

#     return three_part_power_law($m,
#                 $$opts{m0},
#                 $$opts{m1},
#                 $$opts{m2},
#                 $$opts{mmax},
#                 $$opts{p1},
#                 $$opts{p2},
#                 $$opts{p3});
# }

# sub three_part_power_law
# {
#     # generalized three part power law, usually used for mass distributions
#     # args are M, M0, M1, M2, MMAX, P1, P2, P3 (powers)
#     my $m=shift;

#     # use pre-calculated consts if possible, otherwise calculate them
#     my $consts=$threepart_powerlaw_consts{"@_"} //
#     initialize_three_part_power_law_consts(@_);

#     my $p;
#     if($m<$_[1])
#     {
#     $p = $m<$_[0]
#        ? 0.0
#        : $$consts[0]*($m**$_[4]);
#     }
#     elsif($m<$_[3])
#     {
#     $p = $m<$_[2]
#         ? $$consts[1]*($m**$_[5])
#         : $$consts[2]*($m**$_[6]);
#     }
#     else
#     {
#     $p=0.0;
#     }
#     return $p;
# }

# sub gaussian
# {
#     # Gaussian distribution function e.g. for Duquennoy + Mayor 1991

#     # location (X value), mean and sigma, min and max range
#     my ($x,$mean,$sigma,$gmin,$gmax) = @_;

#     my $p;
#     if($x<$gmin || $x>$gmax)
#     {
#     $p=0.0;
#     }
#     else
#     {
#     # normalize over given range
#     my $mult= $gauss_consts{$mean}{$sigma} //
#         gaussian_normalizing_const($mean,$sigma,$gmin,$gmax);
#     $p = $mult * gaussian_func($x,$mean,$sigma);
#     }
#     return $p;
# }

# sub gaussian_normalizing_const
# {
#     # first time: calculate multiplier for given $mean, $sigma
#     my ($mean,$sigma,$gmin,$gmax) = @_;
#     my $ptot=0.0;
#     my $d=($gmax-$gmin)/1000.0;
#     for(my $y=$gmin;$y<=$gmax;$y+=$d)
#     {
#     $ptot += $d * gaussian_func($y,$mean,$sigma);
#     }
#     $gauss_consts{$mean}{$sigma}=$ptot; # save for later
#     return $gauss_consts{$mean}{$sigma};
# }

# sub gaussian_func
# {
#     # local function
#     # three args: x, mean, sigma
#     my $r=1.0/$_[2]; # 1/sigma
#     my $y=($_[0]-$_[1])*$r;
#     return(GAUSSIAN_PREFACTOR*$r*exp(-0.5*$y*$y));
# }
